﻿using System;

namespace V6MMYCS.Business
{

/// <summary>
/// Contains embedded schema and configuration data that is used by the 
/// <see cref="OwnerVehicleTable">V6MMYCS.OwnerVehicleTable</see> class
/// to initialize the class's TableDefinition.
/// </summary>
/// <seealso cref="OwnerVehicleTable"></seealso>
public class OwnerVehicleDefinition
{
#region "Definition (XML) for OwnerVehicleDefinition table"
	//Next 75 lines contain Table Definition (XML) for table "OwnerVehicleDefinition"
	private static string _DefinitionString = 
@"<XMLDefinition Generator=""Iron Speed Designer"" Version=""6.0"" Type=""GENERIC"">" +
  @"<ColumnDefinition>" +
    @"<Column InternalName=""0"" Priority=""1"" ColumnNum=""0"">" +
      @"<columnName>OwnerId</columnName>" +
      @"<columnUIName Source=""Database"">Owner</columnUIName>" +
      @"<columnType>Number</columnType>" +
      @"<columnDBType>Long Integer</columnDBType>" +
      @"<columnLengthSet>10.0</columnLengthSet>" +
      @"<columnDefault></columnDefault>" +
      @"<columnDBDefault></columnDBDefault>" +
      @"<columnIndex>Y</columnIndex>" +
      @"<columnUnique>Y</columnUnique>" +
      @"<columnFunction>notrim</columnFunction>" +
      @"<columnDBFormat></columnDBFormat>" +
      @"<columnPK>Y</columnPK>" +
      @"<columnPermanent>N</columnPermanent>" +
      @"<columnComputed>N</columnComputed>" +
      @"<columnIdentity>N</columnIdentity>" +
      @"<columnReadOnly>N</columnReadOnly>" +
      @"<columnRequired>Y</columnRequired>" +
      @"<columnNotNull>Y</columnNotNull>" +
      @"<columnVisibleWidth>%ISD_DEFAULT%</columnVisibleWidth>" +
      @"<columnTableAliasName></columnTableAliasName>" +
      @"<foreignKey>" +
        @"<columnFKName>OwnerOwnerVehicle</columnFKName>" +
        @"<columnFKTable>V6MMYCS.Business.OwnerTable, App_Code</columnFKTable>" +
        @"<columnFKOwner></columnFKOwner>" +
        @"<columnFKColumn>Id</columnFKColumn>" +
        @"<columnFKColumnDisplay>OwnerName</columnFKColumnDisplay>" +
        @"<foreignKeyType>Explicit</foreignKeyType>" +
      "</foreignKey>" +
    "</Column>" +
    @"<Column InternalName=""1"" Priority=""2"" ColumnNum=""1"">" +
      @"<columnName>VehicleTypeId</columnName>" +
      @"<columnUIName Source=""Database"">Vehicle Type</columnUIName>" +
      @"<columnType>Number</columnType>" +
      @"<columnDBType>Long Integer</columnDBType>" +
      @"<columnLengthSet>10.0</columnLengthSet>" +
      @"<columnDefault></columnDefault>" +
      @"<columnDBDefault></columnDBDefault>" +
      @"<columnIndex>Y</columnIndex>" +
      @"<columnUnique>Y</columnUnique>" +
      @"<columnFunction>notrim</columnFunction>" +
      @"<columnDBFormat></columnDBFormat>" +
      @"<columnPK>Y</columnPK>" +
      @"<columnPermanent>N</columnPermanent>" +
      @"<columnComputed>N</columnComputed>" +
      @"<columnIdentity>N</columnIdentity>" +
      @"<columnReadOnly>N</columnReadOnly>" +
      @"<columnRequired>Y</columnRequired>" +
      @"<columnNotNull>Y</columnNotNull>" +
      @"<columnVisibleWidth>%ISD_DEFAULT%</columnVisibleWidth>" +
      @"<columnTableAliasName></columnTableAliasName>" +
      @"<foreignKey>" +
        @"<columnFKName>VehicleTypeOwnerVehicle</columnFKName>" +
        @"<columnFKTable>V6MMYCS.Business.VehicleTypeTable, App_Code</columnFKTable>" +
        @"<columnFKOwner></columnFKOwner>" +
        @"<columnFKColumn>Id</columnFKColumn>" +
        @"<columnFKColumnDisplay>Make</columnFKColumnDisplay>" +
        @"<foreignKeyType>Explicit</foreignKeyType>" +
      "</foreignKey>" +
    "</Column>" +
  "</ColumnDefinition>" +
  @"<TableName>OwnerVehicle</TableName>" +
  @"<Version></Version>" +
  @"<Owner></Owner>" +
  @"<TableCodeName>OwnerVehicle</TableCodeName>" +
  @"<TableAliasName>OwnerVehicle_</TableAliasName>" +
  @"<ConnectionName>DatabaseTrainingSouthwind.mdb1</ConnectionName>" +
  @"<canCreateRecords Source=""Database"">Y</canCreateRecords>" +
  @"<canEditRecords Source=""Database"">Y</canEditRecords>" +
  @"<canDeleteRecords Source=""Database"">Y</canDeleteRecords>" +
  @"<canViewRecords Source=""Database"">Y</canViewRecords>" +
  @"<AppShortName>V6MMYCS</AppShortName>" +
"</XMLDefinition>";
#endregion

	/// <summary>
	/// Gets the embedded schema and configuration data for the  
	/// <see cref="OwnerVehicleTable"></see>
	/// class's TableDefinition.
	/// </summary>
	/// <remarks>This function is only called once at runtime.</remarks>
	/// <returns>An XML string.</returns>
	public static string GetXMLString()
	{
		return _DefinitionString;
	}
}

}
