﻿
// This file implements the TableControl, TableControlRow, and RecordControl classes for the 
// ShowOwnerTable.aspx page.  The Row or RecordControl classes are the 
// ideal place to add code customizations. For example, you can override the LoadData, 
// CreateWhereClause, DataBind, SaveData, GetUIData, and Validate methods.

#region "Using statements"    

using Microsoft.VisualBasic;
using BaseClasses.Web.UI.WebControls;
using System;
using System.Collections;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using BaseClasses;
using BaseClasses.Data;
using BaseClasses.Utils;
using ReportTools.ReportCreator;
using ReportTools.Shared;




        
using V6MMYCS.Business;
using V6MMYCS.Data;
        

#endregion

  
namespace V6MMYCS.UI.Controls.ShowOwnerTable
{
  

#region "Section 1: Place your customizations here."

    
public class OwnerTableControlRow : BaseOwnerTableControlRow
{
      
        // The BaseOwnerTableControlRow implements code for a ROW within the
        // the OwnerTableControl table.  The BaseOwnerTableControlRow implements the DataBind and SaveData methods.
        // The loading of data is actually performed by the LoadData method in the base class of OwnerTableControl.

        // This is the ideal place to add your code customizations. For example, you can override the DataBind, 
        // SaveData, GetUIData, and Validate methods.
        

}

  

public class OwnerTableControl : BaseOwnerTableControl
{
        // The BaseOwnerTableControl class implements the LoadData, DataBind, CreateWhereClause
        // and other methods to load and display the data in a table control.

        // This is the ideal place to add your code customizations. You can override the LoadData and CreateWhereClause,
        // The OwnerTableControlRow class offers another place where you can customize
        // the DataBind, GetUIData, SaveData and Validate methods specific to each row displayed on the table.

}

  

#endregion

  

#region "Section 2: Do not modify this section."
    
    
// Base class for the OwnerTableControlRow control on the ShowOwnerTable page.
// Do not modify this class. Instead override any method in OwnerTableControlRow.
public class BaseOwnerTableControlRow : V6MMYCS.UI.BaseApplicationRecordControl
{
        public BaseOwnerTableControlRow()
        {
            this.Init += new EventHandler(Control_Init);
            this.Load += new EventHandler(Control_Load);
            this.PreRender += new EventHandler(Control_PreRender);
        }

        // To customize, override this method in OwnerTableControlRow.
        protected virtual void Control_Init(object sender, System.EventArgs e)
        {
            
      
      
            // Register the event handlers.
        
              this.OwnerRowCopyButton.Click += new ImageClickEventHandler(OwnerRowCopyButton_Click);
              
              this.OwnerRowDeleteButton.Click += new ImageClickEventHandler(OwnerRowDeleteButton_Click);
              
              this.OwnerRowEditButton.Click += new ImageClickEventHandler(OwnerRowEditButton_Click);
              
              this.OwnerRowViewButton.Click += new ImageClickEventHandler(OwnerRowViewButton_Click);
              
        }

        // To customize, override this method in OwnerTableControlRow.
        protected virtual void Control_Load(object sender, System.EventArgs e)
        {
        
                // Show confirmation message on Click
                this.OwnerRowDeleteButton.Attributes.Add("onClick", "return (confirm('" + ((BaseApplicationPage)this.Page).GetResourceValue("DeleteRecordConfirm", "V6MMYCS") + "'));");
        }

        // Read data from database. To customize, override this method in OwnerTableControlRow.
        public virtual void LoadData()  
        {
        
        if (this.RecordUniqueId != null && this.RecordUniqueId.Length > 0) {
          this.DataSource = OwnerTable.GetRecord(this.RecordUniqueId, true);
        return;
        }
      
            // Since this is a row in the table, the data for this row is loaded by the 
            // LoadData method of the BaseOwnerTableControl when the data for the entire
            // table is loaded.
            this.DataSource = new OwnerRecord();
          


    }

    // Populate the UI controls using the DataSource. To customize, override this method in OwnerTableControlRow.
        public override void DataBind()
        {
            base.DataBind();

            // Make sure that the DataSource is initialized.
            
                if (this.DataSource == null) {
                return;
                }
              

            // For each field, check to see if a value is specified.  If a value is specified,
            // then format the value for display.  If no value is specified, use the default value (formatted).

        
            if (this.DataSource.AddressSpecified) {
                      
                string formattedValue = this.DataSource.Format(OwnerTable.Address);
                formattedValue = HttpUtility.HtmlEncode(formattedValue);
                if(formattedValue != null){
                    int popupThreshold = (int)(100);
                              
                    int maxLength = formattedValue.Length;
                    if (maxLength > (int)(100)){
                        maxLength = (int)(100);
                        
                    }
                                
                    if (formattedValue.Length >= popupThreshold) {
                         formattedValue = "<a onclick=\'gPersist=true;\' onmouseout=\'detailRolloverPopupClose();\' " +
                            "onmouseover=\'SaveMousePosition(event); delayRolloverPopup(\"PageMethods.GetRecordFieldValue(\\\"V6MMYCS.Business.OwnerTable, App_Code\\\",\\\"" +
                              (HttpUtility.UrlEncode(this.DataSource.GetID().ToString())).Replace("\\","\\\\\\\\") + "\\\", \\\"Address\\\", \\\"Address\\\"," +
                            " false, 200," +
                            " 300, true, PopupDisplayWindowCallBackWith20);\", 500);'>" + NetUtils.EncodeStringForHtmlDisplay(formattedValue.Substring(0, maxLength));
                        if (maxLength == (int)(100))
                            {
                            formattedValue = formattedValue + "..." + "</a>";
                        }
                        else
                        {
                            formattedValue = formattedValue + "</a>";
                            
                        }
                    }
                    else{
                        if (maxLength == (int)(100)) {
                          formattedValue = NetUtils.EncodeStringForHtmlDisplay(formattedValue.Substring(0,maxLength));
                          formattedValue = formattedValue + "...";
                        }
                        
                    }
                }
                
                this.Address.Text = formattedValue;
              
               
            } else {  
                this.Address.Text = OwnerTable.Address.Format(OwnerTable.Address.DefaultValue);
                            
            }
                    
            if (this.Address.Text == null ||
                this.Address.Text.Trim().Length == 0) {
                this.Address.Text = "&nbsp;";
            }
                  
            if (this.DataSource.OwnerNameSpecified) {
                      
                string formattedValue = this.DataSource.Format(OwnerTable.OwnerName);
                formattedValue = HttpUtility.HtmlEncode(formattedValue);
                if(formattedValue != null){
                    int popupThreshold = (int)(100);
                              
                    int maxLength = formattedValue.Length;
                    if (maxLength > (int)(100)){
                        maxLength = (int)(100);
                        
                    }
                                
                    if (formattedValue.Length >= popupThreshold) {
                         formattedValue = "<a onclick=\'gPersist=true;\' onmouseout=\'detailRolloverPopupClose();\' " +
                            "onmouseover=\'SaveMousePosition(event); delayRolloverPopup(\"PageMethods.GetRecordFieldValue(\\\"V6MMYCS.Business.OwnerTable, App_Code\\\",\\\"" +
                              (HttpUtility.UrlEncode(this.DataSource.GetID().ToString())).Replace("\\","\\\\\\\\") + "\\\", \\\"OwnerName\\\", \\\"Owner Name\\\"," +
                            " false, 200," +
                            " 300, true, PopupDisplayWindowCallBackWith20);\", 500);'>" + NetUtils.EncodeStringForHtmlDisplay(formattedValue.Substring(0, maxLength));
                        if (maxLength == (int)(100))
                            {
                            formattedValue = formattedValue + "..." + "</a>";
                        }
                        else
                        {
                            formattedValue = formattedValue + "</a>";
                            
                        }
                    }
                    else{
                        if (maxLength == (int)(100)) {
                          formattedValue = NetUtils.EncodeStringForHtmlDisplay(formattedValue.Substring(0,maxLength));
                          formattedValue = formattedValue + "...";
                        }
                        
                    }
                }
                
                this.OwnerName.Text = formattedValue;
              
               
            } else {  
                this.OwnerName.Text = OwnerTable.OwnerName.Format(OwnerTable.OwnerName.DefaultValue);
                            
            }
                    
            if (this.OwnerName.Text == null ||
                this.OwnerName.Text.Trim().Length == 0) {
                this.OwnerName.Text = "&nbsp;";
            }
                  
            this.IsNewRecord = true;
            if (this.DataSource.IsCreated) {
                this.IsNewRecord = false;
        
                this.RecordUniqueId = this.DataSource.GetID().ToXmlString();
            }

            

            // Load data for each record and table UI control.
            // Ordering is important because child controls get 
            // their parent ids from their parent UI controls.
            bool shouldResetControl = false;
            
        }


        

        //  To customize, override this method in OwnerTableControlRow.
        public virtual void SaveData()
        {
            // 1. Load the existing record from the database. Since we save the entire record, this ensures 
            // that fields that are not displayed also properly initialized.
            this.LoadData();
        


          // 2. Validate the data.  Override in OwnerTableControlRow to add custom validation.
          this.Validate();

           // 3. Set the values in the record with data from UI controls.  Override in OwnerTableControlRow to set additional fields.
          this.GetUIData();
   
    

     
          // 4. Save in the database.
          // We should not save the record if the data did not change. This
          // will save a database hit and avoid triggering any database triggers.
          if (this.DataSource.IsAnyValueChanged) {
          // Save record to database but do not commit.
          // Auto generated ids are available after saving for use by child (dependent) records.
          this.DataSource.Save();
    
                ((OwnerTableControl)MiscUtils.GetParentControlObject(this, "OwnerTableControl")).DataChanged = true;
                ((OwnerTableControl)MiscUtils.GetParentControlObject(this, "OwnerTableControl")).ResetData = true;
            }
            // Reseting of this.IsNewRecord is moved to Save button's click even handler.
            // this.IsNewRecord = false;
            this.DataChanged = true;
            this.ResetData = true;
                
    }

        //  To customize, override this method in OwnerTableControlRow.
        public virtual void GetUIData()
        {
        
      }

      

        //  To customize, override this method in OwnerTableControlRow.
        public virtual WhereClause CreateWhereClause()
        {
        
            return null;
          
        }
        
        

        //  To customize, override this method in OwnerTableControlRow.
        public virtual void Validate()
        {
            // Initially empty.  Override to add custom validation.
        }

        public virtual void Delete()
        {
        
            if (this.IsNewRecord) {
                return;
            }

            KeyValue pk = KeyValue.XmlToKey(this.RecordUniqueId);
            OwnerTable.DeleteRecord(pk);

          
            ((OwnerTableControl)MiscUtils.GetParentControlObject(this, "OwnerTableControl")).DataChanged = true;
            ((OwnerTableControl)MiscUtils.GetParentControlObject(this, "OwnerTableControl")).ResetData = true;
        }

        private void Control_PreRender(object sender, System.EventArgs e)
        {
            try {
                DbUtils.StartTransaction();

                if (!this.Page.ErrorOnPage && (this.Page.IsPageRefresh || this.DataChanged || this.ResetData)) {
                    this.LoadData();
                    this.DataBind();
                }

            } catch (Exception ex) {
                BaseClasses.Utils.MiscUtils.RegisterJScriptAlert(this, "BUTTON_CLICK_MESSAGE", ex.Message);
            } finally {
                DbUtils.EndTransaction();
            }
        }
        
        
                
        protected override void LoadViewState(object savedState)
        {
            base.LoadViewState(savedState);
            string isNewRecord = (string)ViewState["IsNewRecord"];
            if (isNewRecord != null && isNewRecord.Length > 0) {
                this.IsNewRecord = Boolean.Parse(isNewRecord);
            }
        
            string myCheckSum = (string)ViewState["CheckSum"];
            if (myCheckSum != null && myCheckSum.Length > 0) {
                this.CheckSum = myCheckSum;
            }
        
        }

        protected override object SaveViewState()
        {
            ViewState["IsNewRecord"] = this.IsNewRecord.ToString();
            ViewState["CheckSum"] = this.CheckSum;
        
            return base.SaveViewState();
        }

        
        // event handler for ImageButton
        public virtual void OwnerRowCopyButton_Click(object sender, ImageClickEventArgs args)
        {
        
            string url = @"../Owner/AddOwner.aspx?Owner={PK}";
            bool shouldRedirect = true;
            string TargetKey;
            string tk = null;
            TargetKey = tk;
            
            try {
                DbUtils.StartTransaction();
                
                url = this.ModifyRedirectUrl(url, "",false);
                url = this.Page.ModifyRedirectUrl(url, "",false);
                        this.Page.CommitTransaction(sender);
    
      
            } catch (Exception ex) {
                this.Page.RollBackTransaction(sender);
                shouldRedirect = false;
                this.Page.ErrorOnPage = true;
    
            BaseClasses.Utils.MiscUtils.RegisterJScriptAlert(this, "BUTTON_CLICK_MESSAGE", ex.Message);
          
            } finally {
                DbUtils.EndTransaction();
            }
            if (shouldRedirect) {
                this.Page.ShouldSaveControlsToSession = true;
                this.Page.Response.Redirect(url);
            }
        
            else if (TargetKey != null && !shouldRedirect){
            this.Page.ShouldSaveControlsToSession = true ; 
            this.Page.CloseWindow(true);
            }
        
        }
            
        // event handler for ImageButton
        public virtual void OwnerRowDeleteButton_Click(object sender, ImageClickEventArgs args)
        {
        
            try {
                DbUtils.StartTransaction();
                
            if (!this.Page.IsPageRefresh) {
        
                this.Delete();
              
            }
                this.Page.CommitTransaction(sender);
    
      
            } catch (Exception ex) {
                this.Page.RollBackTransaction(sender);
                this.Page.ErrorOnPage = true;
    
            BaseClasses.Utils.MiscUtils.RegisterJScriptAlert(this, "BUTTON_CLICK_MESSAGE", ex.Message);
          
            } finally {
                DbUtils.EndTransaction();
            }
    
        }
            
        // event handler for ImageButton
        public virtual void OwnerRowEditButton_Click(object sender, ImageClickEventArgs args)
        {
        
            string url = @"../Owner/EditOwner.aspx?Owner={PK}";
            bool shouldRedirect = true;
            string TargetKey;
            string tk = null;
            TargetKey = tk;
            
            try {
                DbUtils.StartTransaction();
                
                url = this.ModifyRedirectUrl(url, "",false);
                url = this.Page.ModifyRedirectUrl(url, "",false);
                        this.Page.CommitTransaction(sender);
    
      
            } catch (Exception ex) {
                this.Page.RollBackTransaction(sender);
                shouldRedirect = false;
                this.Page.ErrorOnPage = true;
    
            BaseClasses.Utils.MiscUtils.RegisterJScriptAlert(this, "BUTTON_CLICK_MESSAGE", ex.Message);
          
            } finally {
                DbUtils.EndTransaction();
            }
            if (shouldRedirect) {
                this.Page.ShouldSaveControlsToSession = true;
                this.Page.Response.Redirect(url);
            }
        
            else if (TargetKey != null && !shouldRedirect){
            this.Page.ShouldSaveControlsToSession = true ; 
            this.Page.CloseWindow(true);
            }
        
        }
            
        // event handler for ImageButton
        public virtual void OwnerRowViewButton_Click(object sender, ImageClickEventArgs args)
        {
        
            string url = @"../Owner/ShowOwner.aspx?Owner={PK}";
            bool shouldRedirect = true;
            string TargetKey;
            string tk = null;
            TargetKey = tk;
            
            try {
                DbUtils.StartTransaction();
                
                url = this.ModifyRedirectUrl(url, "",false);
                url = this.Page.ModifyRedirectUrl(url, "",false);
                        this.Page.CommitTransaction(sender);
    
      
            } catch (Exception ex) {
                this.Page.RollBackTransaction(sender);
                shouldRedirect = false;
                this.Page.ErrorOnPage = true;
    
            BaseClasses.Utils.MiscUtils.RegisterJScriptAlert(this, "BUTTON_CLICK_MESSAGE", ex.Message);
          
            } finally {
                DbUtils.EndTransaction();
            }
            if (shouldRedirect) {
                this.Page.ShouldSaveControlsToSession = true;
                this.Page.Response.Redirect(url);
            }
        
            else if (TargetKey != null && !shouldRedirect){
            this.Page.ShouldSaveControlsToSession = true ; 
            this.Page.CloseWindow(true);
            }
        
        }
            
  
        private bool _IsNewRecord = true;
        public virtual bool IsNewRecord {
            get {
                return this._IsNewRecord;
            }
            set {
                this._IsNewRecord = value;
            }
        }

        private bool _DataChanged = false;
        public virtual bool DataChanged {
            get {
                return this._DataChanged;
            }
            set {
                this._DataChanged = value;
            }
        }

        private bool _ResetData = false;
        public virtual bool ResetData {
            get {
                return (this._ResetData);
            }
            set {
                this._ResetData = value;
            }
        }
        
        public String RecordUniqueId {
            get {
                return (string)this.ViewState["BaseOwnerTableControlRow_Rec"];
            }
            set {
                this.ViewState["BaseOwnerTableControlRow_Rec"] = value;
            }
        }
        
        private OwnerRecord _DataSource;
        public OwnerRecord DataSource {
            get {
                return (this._DataSource);
            }
            set {
                this._DataSource = value;
            }
        }

        private string _checkSum;
        public virtual string CheckSum {
            get {
                return (this._checkSum);
            }
            set {
                this._checkSum = value;
            }
        }
    
        private int _TotalPages;
        public virtual int TotalPages {
            get {
                return (this._TotalPages);
            }
            set {
                this._TotalPages = value;
            }
        }
        
        private int _PageIndex;
        public virtual int PageIndex {
            get {
                return (this._PageIndex);
            }
            set {
                this._PageIndex = value;
            }
        }
    
        private bool _DisplayLastPage;
        public virtual bool DisplayLastPage {
            get {
                return (this._DisplayLastPage);
            }
            set {
                this._DisplayLastPage = value;
            }
        }
        
        
    
        private KeyValue selectedParentKeyValue;
        public KeyValue SelectedParentKeyValue
        {
            get
            {
                return this.selectedParentKeyValue;
            }
            set
            {
                this.selectedParentKeyValue = value;
            }
        }
       
#region "Helper Properties"
        
        public System.Web.UI.WebControls.Literal Address {
            get {
                return (System.Web.UI.WebControls.Literal)BaseClasses.Utils.MiscUtils.FindControlRecursively(this, "Address");
            }
        }
            
        public System.Web.UI.WebControls.Literal OwnerName {
            get {
                return (System.Web.UI.WebControls.Literal)BaseClasses.Utils.MiscUtils.FindControlRecursively(this, "OwnerName");
            }
        }
            
        public System.Web.UI.WebControls.CheckBox OwnerRecordRowSelection {
            get {
                return (System.Web.UI.WebControls.CheckBox)BaseClasses.Utils.MiscUtils.FindControlRecursively(this, "OwnerRecordRowSelection");
            }
        }
        
        public System.Web.UI.WebControls.ImageButton OwnerRowCopyButton {
            get {
                return (System.Web.UI.WebControls.ImageButton)BaseClasses.Utils.MiscUtils.FindControlRecursively(this, "OwnerRowCopyButton");
            }
        }
        
        public System.Web.UI.WebControls.ImageButton OwnerRowDeleteButton {
            get {
                return (System.Web.UI.WebControls.ImageButton)BaseClasses.Utils.MiscUtils.FindControlRecursively(this, "OwnerRowDeleteButton");
            }
        }
        
        public System.Web.UI.WebControls.ImageButton OwnerRowEditButton {
            get {
                return (System.Web.UI.WebControls.ImageButton)BaseClasses.Utils.MiscUtils.FindControlRecursively(this, "OwnerRowEditButton");
            }
        }
        
        public System.Web.UI.WebControls.ImageButton OwnerRowViewButton {
            get {
                return (System.Web.UI.WebControls.ImageButton)BaseClasses.Utils.MiscUtils.FindControlRecursively(this, "OwnerRowViewButton");
            }
        }
        
#endregion

#region "Helper Functions"
        public override string ModifyRedirectUrl(string url, string arg, bool bEncrypt)
    {
      return this.Page.EvaluateExpressions(url, arg, bEncrypt, this);
    }

        public override string EvaluateExpressions(string url, string arg, bool bEncrypt)
        {
            OwnerRecord rec = null;
            try {
                rec = this.GetRecord();
            }
            catch (Exception ) {
                // Do Nothing
            }
            
      if (rec == null && url.IndexOf("{") >= 0) {
                // Localization.
                
            throw new Exception(Page.GetResourceValue("Err:RecDataSrcNotInitialized", "V6MMYCS"));
                    
            }
        return EvaluateExpressions(url, arg, rec, bEncrypt);
        }

        public virtual OwnerRecord GetRecord()
        {
        
            if (this.DataSource != null) {
                return this.DataSource;
            }
            
            if (this.RecordUniqueId != null) {
                return OwnerTable.GetRecord(this.RecordUniqueId, true);
            }
            
            // Localization.
            
            throw new Exception(Page.GetResourceValue("Err:RetrieveRec", "V6MMYCS"));
                
        }

        public new BaseApplicationPage Page
        {
            get {
                return ((BaseApplicationPage)base.Page);
            }
        }

#endregion

}

  
// Base class for the OwnerTableControl control on the ShowOwnerTable page.
// Do not modify this class. Instead override any method in OwnerTableControl.
public class BaseOwnerTableControl : V6MMYCS.UI.BaseApplicationTableControl
{
        public BaseOwnerTableControl()
        {
            this.Init += new EventHandler(Control_Init);
            this.Load += new EventHandler(Control_Load);
            this.PreRender += new EventHandler(Control_PreRender);
        }

        protected virtual void Control_Init(object sender, System.EventArgs e)
        {
            // Setup the pagination events.
        
              this.OwnerPagination.FirstPage.Click += new ImageClickEventHandler(OwnerPagination_FirstPage_Click);
              
              this.OwnerPagination.LastPage.Click += new ImageClickEventHandler(OwnerPagination_LastPage_Click);
              
              this.OwnerPagination.NextPage.Click += new ImageClickEventHandler(OwnerPagination_NextPage_Click);
              
              this.OwnerPagination.PageSizeButton.Click += new EventHandler(OwnerPagination_PageSizeButton_Click);
            
              this.OwnerPagination.PreviousPage.Click += new ImageClickEventHandler(OwnerPagination_PreviousPage_Click);
              

            // Setup the sorting events.
        
              this.AddressLabel1.Click += new EventHandler(AddressLabel1_Click);
            
              this.OwnerNameLabel1.Click += new EventHandler(OwnerNameLabel1_Click);
            

            // Setup the button events.
        
              this.OwnerCopyButton.Click += new ImageClickEventHandler(OwnerCopyButton_Click);
              
              this.OwnerDeleteButton.Click += new ImageClickEventHandler(OwnerDeleteButton_Click);
              
              this.OwnerEditButton.Click += new ImageClickEventHandler(OwnerEditButton_Click);
              
              this.OwnerExportButton.Click += new ImageClickEventHandler(OwnerExportButton_Click);
              
              this.Page.RegisterPostBackTrigger(MiscUtils.FindControlRecursively(this,"OwnerExportButton"), MiscUtils.FindControlRecursively(this.Page,"UpdatePanel1"));
                        
              this.OwnerExportExcelButton.Click += new ImageClickEventHandler(OwnerExportExcelButton_Click);
              
              this.Page.RegisterPostBackTrigger(MiscUtils.FindControlRecursively(this,"OwnerExportExcelButton"), MiscUtils.FindControlRecursively(this.Page,"UpdatePanel1"));
                        
              this.OwnerImportButton.Click += new ImageClickEventHandler(OwnerImportButton_Click);
              
              this.OwnerNewButton.Click += new ImageClickEventHandler(OwnerNewButton_Click);
              
              this.OwnerPDFButton.Click += new ImageClickEventHandler(OwnerPDFButton_Click);
              
              this.Page.RegisterPostBackTrigger(MiscUtils.FindControlRecursively(this,"OwnerPDFButton"), MiscUtils.FindControlRecursively(this.Page,"UpdatePanel1"));
                        
              this.OwnerRefreshButton.Click += new ImageClickEventHandler(OwnerRefreshButton_Click);
              
              this.OwnerResetButton.Click += new ImageClickEventHandler(OwnerResetButton_Click);
              
              this.OwnerWordButton.Click += new ImageClickEventHandler(OwnerWordButton_Click);
              
              this.Page.RegisterPostBackTrigger(MiscUtils.FindControlRecursively(this,"OwnerWordButton"), MiscUtils.FindControlRecursively(this.Page,"UpdatePanel1"));
                        
              this.OwnerSearchButton.Button.Click += new EventHandler(OwnerSearchButton_Click);
              

            // Setup the filter and search events.
        
            this.AddressFilter.SelectedIndexChanged += new EventHandler(AddressFilter_SelectedIndexChanged);
            this.OwnerNameFilter.SelectedIndexChanged += new EventHandler(OwnerNameFilter_SelectedIndexChanged);
            if (!this.Page.IsPostBack && this.InSession(this.AddressFilter)) {
                this.AddressFilter.Items.Add(new ListItem(this.GetFromSession(this.AddressFilter), this.GetFromSession(this.AddressFilter)));
                this.AddressFilter.SelectedValue = this.GetFromSession(this.AddressFilter);
                
            }
            if (!this.Page.IsPostBack && this.InSession(this.OwnerNameFilter)) {
                this.OwnerNameFilter.Items.Add(new ListItem(this.GetFromSession(this.OwnerNameFilter), this.GetFromSession(this.OwnerNameFilter)));
                this.OwnerNameFilter.SelectedValue = this.GetFromSession(this.OwnerNameFilter);
                
            }
            if (!this.Page.IsPostBack && this.InSession(this.OwnerSearchArea)) {
                
                this.OwnerSearchArea.Text = this.GetFromSession(this.OwnerSearchArea);
                
            }

            // Control Initializations.
            // Initialize the table's current sort order.
            if (this.InSession(this, "Order_By")) {
                this.CurrentSortOrder = OrderBy.FromXmlString(this.GetFromSession(this, "Order_By", null));
            } else {
                this.CurrentSortOrder = new OrderBy(true, true);
        
            }

    // Setup default pagination settings.
    
            this.PageSize = Convert.ToInt32(this.GetFromSession(this, "Page_Size", "10"));
            this.PageIndex = Convert.ToInt32(this.GetFromSession(this, "Page_Index", "0"));
            this.ClearControlsFromSession();
        }

        protected virtual void Control_Load(object sender, EventArgs e)
        {
        
            SaveControlsToSession_Ajax();
        
                // Show confirmation message on Click
                this.OwnerDeleteButton.Attributes.Add("onClick", "return (confirm('" + ((BaseApplicationPage)this.Page).GetResourceValue("DeleteConfirm", "V6MMYCS") + "'));");
    }

    // Read data from database. Returns an array of records that can be assigned
    // to the DataSource table control property.
    public virtual void LoadData()
    {
    try {


      
                // The WHERE clause will be empty when displaying all records in table.
                WhereClause wc = CreateWhereClause();
                if (wc != null && !wc.RunQuery) {
                    // Initialize an empty array of records
                    ArrayList alist = new ArrayList(0);
                    this.DataSource = (OwnerRecord[])(alist.ToArray(Type.GetType("V6MMYCS.Business.OwnerRecord")));
                    // Add records to the list if needed.
                    this.AddNewRecords();
                    return;
                }

                OrderBy orderBy = CreateOrderBy();

                // Get the pagesize from the pagesize control.
                this.GetPageSize();

                // Get the total number of records to be displayed.
                this.TotalRecords = OwnerTable.GetRecordCount(wc);

                // Go to the last page.
                if (this.TotalPages <= 0 || this.PageIndex < 0) {
                    this.PageIndex = 0;
                } else if (this.DisplayLastPage || this.PageIndex >= this.TotalPages) {
                    this.PageIndex = this.TotalPages - 1;
                }

                // Retrieve the records and set the table DataSource.
                // Only PageSize records are fetched starting at PageIndex (zero based).
                if (this.TotalRecords <= 0) {
                    // Initialize an empty array of records
                    ArrayList alist = new ArrayList(0);
                    this.DataSource = (OwnerRecord[])(alist.ToArray(Type.GetType("V6MMYCS.Business.OwnerRecord")));
                } else if (this.AddNewRecord > 0) {
                    // Get the records from the posted data
                    ArrayList postdata = new ArrayList(0);
                    foreach (OwnerTableControlRow rc in this.GetRecordControls()) {
                        if (!rc.IsNewRecord) {
                            rc.DataSource = rc.GetRecord();
                            rc.GetUIData();
                            postdata.Add(rc.DataSource);
                        }
                    }
                    this.DataSource = (OwnerRecord[])(postdata.ToArray(Type.GetType("V6MMYCS.Business.OwnerRecord")));
                } else {
                    // Get the records from the database
                    this.DataSource = OwnerTable.GetRecords(wc, orderBy, this.PageIndex, this.PageSize);
                }
                // Add records to the list.
                this.AddNewRecords();
            
                // Turn off the ToggleAll checkbox
                this.OwnerToggleAll.Checked = false;
            

                // Initialize the page and grand totals. now
            
            } catch (Exception ex) {
                throw ex;
            }
        }

        // Populate the UI controls.
        public override void DataBind()
        {
            base.DataBind();
            
         
            // Make sure that the DataSource is initialized.
            if (this.DataSource == null) {
                return;
            }
           

            // Setup the pagination controls.
            BindPaginationControls();

            // Populate all filters data.
        
            this.PopulateAddressFilter(MiscUtils.GetSelectedValue(this.AddressFilter, this.GetFromSession(this.AddressFilter)), 500);
                    
            this.PopulateOwnerNameFilter(MiscUtils.GetSelectedValue(this.OwnerNameFilter, this.GetFromSession(this.OwnerNameFilter)), 500);
                    

            // Bind the repeater with the list of records to expand the UI.
            System.Web.UI.WebControls.Repeater rep = (System.Web.UI.WebControls.Repeater)(this.FindControl("OwnerTableControlRepeater"));
      if (rep == null){return;}
            rep.DataSource = this.DataSource;
            rep.DataBind();


            int index = 0;
            foreach (System.Web.UI.WebControls.RepeaterItem repItem in rep.Items)
            {
                // Loop through all rows in the table, set its DataSource and call DataBind().
                OwnerTableControlRow recControl = (OwnerTableControlRow)(repItem.FindControl("OwnerTableControlRow"));
                recControl.DataSource = this.DataSource[index];
                recControl.DataBind();
                recControl.Visible = !this.InDeletedRecordIds(recControl);
                index++;
            }

        
      // setting the state of expand or collapse alternative rows
      
}

         

        public virtual void ResetControl()
        {
            
              this.AddressFilter.ClearSelection();
            
              this.OwnerNameFilter.ClearSelection();
            
              this.OwnerSearchArea.Text = "";
            
              this.CurrentSortOrder.Reset();
              if (this.InSession(this, "Order_By")) {
              this.CurrentSortOrder = OrderBy.FromXmlString(this.GetFromSession(this, "Order_By", null));
              } else {
              this.CurrentSortOrder = new OrderBy(true, true);
            
            }
                
            this.PageIndex = 0;
        }
        
        
        protected virtual void BindPaginationControls()
        {
            // Setup the pagination controls.

            // Bind the buttons for OwnerTableControl pagination.
        
            this.OwnerPagination.FirstPage.Enabled = !(this.PageIndex == 0);
            this.OwnerPagination.LastPage.Enabled = !(this.PageIndex == this.TotalPages - 1);
            if (this.TotalPages == 0) {
                this.OwnerPagination.LastPage.Enabled = false;
            }
          
            this.OwnerPagination.NextPage.Enabled = !(this.PageIndex == this.TotalPages - 1);
            if (this.TotalPages == 0) {
                this.OwnerPagination.NextPage.Enabled = false;
            }
          
            this.OwnerPagination.PreviousPage.Enabled = !(this.PageIndex == 0);

            // Bind the pagination labels.
        
            if (this.TotalPages > 0) {
                this.OwnerPagination.CurrentPage.Text = (this.PageIndex + 1).ToString();
            } else {
                this.OwnerPagination.CurrentPage.Text = "0";
            }
            this.OwnerPagination.PageSize.Text = this.PageSize.ToString();
            this.OwnerPagination.TotalItems.Text = this.TotalRecords.ToString();
            this.OwnerPagination.TotalPages.Text = this.TotalPages.ToString();
        }

        public virtual void SaveData()
        {
            foreach (OwnerTableControlRow recCtl in this.GetRecordControls())
            {
        
                if (this.InDeletedRecordIds(recCtl)) {
                    recCtl.Delete();
                } else {
                    if (recCtl.Visible) {
                        recCtl.SaveData();
                    }
                }
          
            }
            
            this.DataChanged = true;
            this.ResetData = true;
        }
        
        public virtual OrderBy CreateOrderBy()
        {
            return this.CurrentSortOrder;
        }
        
        private string parentSelectedKeyValue;
        public string ParentSelectedKeyValue
        {
          get
          {
            return parentSelectedKeyValue;
          }
          set
          {
            parentSelectedKeyValue = value;
          }
        }

        // This CreateWhereClause is used for loading the data.
        public virtual WhereClause CreateWhereClause()
        {
            OwnerTable.Instance.InnerFilter = null;
      WhereClause wc = new WhereClause();
      // CreateWhereClause() Compose the WHERE clause consiting of:
      // 1. Static clause defined at design time.
      // 2. User selected filter criteria.
      // 3. User selected search criteria.

        
            if (MiscUtils.IsValueSelected(this.AddressFilter)) {
                        
                wc.iAND(OwnerTable.Address, BaseFilter.ComparisonOperator.EqualsTo, MiscUtils.GetSelectedValue(this.AddressFilter, this.GetFromSession(this.AddressFilter)), false, false);
                    
            }
                      
            if (MiscUtils.IsValueSelected(this.OwnerNameFilter)) {
                        
                wc.iAND(OwnerTable.OwnerName, BaseFilter.ComparisonOperator.EqualsTo, MiscUtils.GetSelectedValue(this.OwnerNameFilter, this.GetFromSession(this.OwnerNameFilter)), false, false);
                    
            }
                      
            if (MiscUtils.IsValueSelected(this.OwnerSearchArea)) {
                // Strip "..." from begin and ending of the search text, otherwise the search will return 0 values as in database "..." is not stored.
                if (this.OwnerSearchArea.Text.StartsWith("...")) {
                    this.OwnerSearchArea.Text = this.OwnerSearchArea.Text.Substring(3,this.OwnerSearchArea.Text.Length-3);
                }
                if (this.OwnerSearchArea.Text.EndsWith("...")) {
                    this.OwnerSearchArea.Text = this.OwnerSearchArea.Text.Substring(0,this.OwnerSearchArea.Text.Length-3);
                }
                // After stripping "..." see if the search text is null or empty.
                if (MiscUtils.IsValueSelected(this.OwnerSearchArea)) {
                      
                    // These clauses are added depending on operator and fields selected in Control's property page, bindings tab.
                    WhereClause search = new WhereClause();
                    
                    search.iOR(OwnerTable.OwnerName, BaseFilter.ComparisonOperator.Contains, MiscUtils.GetSelectedValue(this.OwnerSearchArea, this.GetFromSession(this.OwnerSearchArea)), true, false);
        
                    search.iOR(OwnerTable.Address, BaseFilter.ComparisonOperator.Contains, MiscUtils.GetSelectedValue(this.OwnerSearchArea, this.GetFromSession(this.OwnerSearchArea)), true, false);
        
                    wc.iAND(search);
                }
            }
                  
            return (wc);
        }
        
         
        // This CreateWhereClause is used for loading list of suggestions for Auto Type-Ahead feature.
        public virtual WhereClause CreateWhereClause(String searchText, String fromSearchControl, String AutoTypeAheadSearch, String AutoTypeAheadWordSeparators)
        {
            OwnerTable.Instance.InnerFilter = null;
            WhereClause wc= new WhereClause();
            // Compose the WHERE clause consiting of:
            // 1. Static clause defined at design time.
            // 2. User selected filter criteria.
            // 3. User selected search criteria.
            String appRelativeVirtualPath = (String)HttpContext.Current.Session["AppRelativeVirtualPath"];
            
            
            // Adds clauses if values are selected in Filter controls which are configured in the page.
          
      String AddressFilterSelectedValue = (String)HttpContext.Current.Session[HttpContext.Current.Session.SessionID + appRelativeVirtualPath + "AddressFilter_Ajax"];
            if (MiscUtils.IsValueSelected(AddressFilterSelectedValue)) {
              
                wc.iAND(OwnerTable.Address, BaseFilter.ComparisonOperator.EqualsTo, AddressFilterSelectedValue, false, false);
                      
      }
                      
      String OwnerNameFilterSelectedValue = (String)HttpContext.Current.Session[HttpContext.Current.Session.SessionID + appRelativeVirtualPath + "OwnerNameFilter_Ajax"];
            if (MiscUtils.IsValueSelected(OwnerNameFilterSelectedValue)) {
              
                wc.iAND(OwnerTable.OwnerName, BaseFilter.ComparisonOperator.EqualsTo, OwnerNameFilterSelectedValue, false, false);
                      
      }
                      
            if (MiscUtils.IsValueSelected(searchText) && fromSearchControl == "OwnerSearchArea") {
                String formatedSearchText = searchText;
                // strip "..." from begin and ending of the search text, otherwise the search will return 0 values as in database "..." is not stored.
                if (searchText.StartsWith("...")) {
                    formatedSearchText = searchText.Substring(3,searchText.Length-3);
                }
                if (searchText.EndsWith("...")) {
                    formatedSearchText = searchText.Substring(0,searchText.Length-3);
                }
                // After stripping "...", trim any leading and trailing whitespaces 
                formatedSearchText = formatedSearchText.Trim();
                // After stripping "..." see if the search text is null or empty.
                if (MiscUtils.IsValueSelected(searchText)) {
                      
                    // These clauses are added depending on operator and fields selected in Control's property page, bindings tab.
                    WhereClause search = new WhereClause();
                    
                    if (StringUtils.InvariantLCase(AutoTypeAheadSearch).Equals("wordsstartingwithsearchstring")) {
                
                        search.iOR(OwnerTable.OwnerName, BaseFilter.ComparisonOperator.Starts_With, formatedSearchText, true, false);
                        search.iOR(OwnerTable.OwnerName, BaseFilter.ComparisonOperator.Contains, AutoTypeAheadWordSeparators + formatedSearchText, true, false);
                  
                
                        search.iOR(OwnerTable.Address, BaseFilter.ComparisonOperator.Starts_With, formatedSearchText, true, false);
                        search.iOR(OwnerTable.Address, BaseFilter.ComparisonOperator.Contains, AutoTypeAheadWordSeparators + formatedSearchText, true, false);
                  
                
                    } else {
                        
                        search.iOR(OwnerTable.OwnerName, BaseFilter.ComparisonOperator.Contains, formatedSearchText, true, false);
                        search.iOR(OwnerTable.Address, BaseFilter.ComparisonOperator.Contains, formatedSearchText, true, false);
                    } 
                    wc.iAND(search);
                }
            }
                  
            return wc;
        }
          
         public virtual string[] GetAutoCompletionList_OwnerSearchArea(String prefixText,int count)
         {
            ArrayList resultList = new ArrayList();
            ArrayList wordList= new ArrayList();
            int iteration = 0;
            
            WhereClause wc= CreateWhereClause(prefixText,"OwnerSearchArea", "WordsStartingWithSearchString", "[!a-zA-Z0-9]");
            while (resultList.Count < count && iteration < 5){
                // Fetch 100 records in each iteration
                V6MMYCS.Business.OwnerRecord[] records = OwnerTable.GetRecords(wc, null, iteration, 100);
                String resultItem = "";
                foreach (OwnerRecord rec in records){
                    // Exit the loop if recordList count has reached AutoTypeAheadListSize.
                    if (resultList.Count >= count) {
                        break;
                    }
                    // If the field is configured to Display as Foreign key, Format() method returns the 
                    // Display as Forien Key value instead of original field value.
                    // Since search had to be done in multiple fields (selected in Control's page property, binding tab) in a record,
                    // We need to find relevent field to display which matches the prefixText and is not already present in the result list.
            
                    resultItem = rec.Format(OwnerTable.OwnerName);
                    if (resultItem != null && resultItem.ToUpper(System.Threading.Thread.CurrentThread.CurrentCulture).Contains(prefixText.ToUpper(System.Threading.Thread.CurrentThread.CurrentCulture))) {
                        bool isAdded = FormatSuggestions(prefixText, resultItem, 50, "AtBeginningOfMatchedString", "WordsStartingWithSearchString", "[^a-zA-Z0-9]", resultList);
                        if (isAdded) {
                            continue;
                        }
                    }
      
                    resultItem = rec.Format(OwnerTable.Address);
                    if (resultItem != null && resultItem.ToUpper(System.Threading.Thread.CurrentThread.CurrentCulture).Contains(prefixText.ToUpper(System.Threading.Thread.CurrentThread.CurrentCulture))) {
                        bool isAdded = FormatSuggestions(prefixText, resultItem, 50, "AtBeginningOfMatchedString", "WordsStartingWithSearchString", "[^a-zA-Z0-9]", resultList);
                        if (isAdded) {
                            continue;
                        }
                    }
      
                }
                // Exit the loop if number of records found is less as further iteration will not return any more records
                if (records.Length < 100 ) {
                    break;
                }
                iteration++;
            }
            resultList.Sort();
            string[] result = new string[resultList.Count];
            Array.Copy(resultList.ToArray(), result, resultList.Count);
            return result;
        }
          
        // Formats the result Item and adds it to the list of suggestions.
        public virtual bool FormatSuggestions(String prefixText, String resultItem,
                                              int columnLength, String AutoTypeAheadDisplayFoundText,
                                              String autoTypeAheadSearch, String AutoTypeAheadWordSeparators,
                                              ArrayList resultList)
        {
            int index  = resultItem.ToUpper(System.Threading.Thread.CurrentThread.CurrentCulture).IndexOf(prefixText.ToUpper(System.Threading.Thread.CurrentThread.CurrentCulture));
            String itemToAdd = null;
            bool isFound = false;
            bool isAdded = false;
            if (StringUtils.InvariantLCase(autoTypeAheadSearch).Equals("wordsstartingwithsearchstring") && !(index == 0)) {
                 // Expression to find word which contains AutoTypeAheadWordSeparators followed by prefixText
                System.Text.RegularExpressions.Regex regex1 = new System.Text.RegularExpressions.Regex( AutoTypeAheadWordSeparators + prefixText, System.Text.RegularExpressions.RegexOptions.IgnoreCase);
                if (regex1.IsMatch(resultItem)) {
                    index = regex1.Match(resultItem).Index;
                    isFound = true;
                }
                //If the prefixText is found immediatly after white space then starting of the word is found so don not search any further
                if (resultItem[index].ToString() != " ") {
                    // Expression to find beginning of the word which contains AutoTypeAheadWordSeparators followed by prefixText
                    System.Text.RegularExpressions.Regex regex = new System.Text.RegularExpressions.Regex("\\S*" + AutoTypeAheadWordSeparators + prefixText, System.Text.RegularExpressions.RegexOptions.IgnoreCase);
                    if (regex.IsMatch(resultItem)) {
                        index = regex.Match(resultItem).Index;
                        isFound = true;
                    }
                }
            }
            // If autoTypeAheadSearch value is wordsstartingwithsearchstring then, extract the substring only if the prefixText is found at the 
            // beginning of the resultItem (index = 0) or a word in resultItem is found starts with prefixText. 
            if (index == 0 || isFound || StringUtils.InvariantLCase(autoTypeAheadSearch).Equals("anywhereinstring")) {
                if (StringUtils.InvariantLCase(AutoTypeAheadDisplayFoundText).Equals("atbeginningofmatchedstring")) {
                    // Expression to find beginning of the word which contains prefixText
                    System.Text.RegularExpressions.Regex regex1 = new System.Text.RegularExpressions.Regex("\\S*" + prefixText, System.Text.RegularExpressions.RegexOptions.IgnoreCase);
                    //  Find the beginning of the word which contains prefexText
                    if (StringUtils.InvariantLCase(autoTypeAheadSearch).Equals("anywhereinstring") && regex1.IsMatch(resultItem)) {
                        index = regex1.Match(resultItem).Index;
                        isFound = true;
                    }
                    // Display string from the index till end of the string if, sub string from index till end of string is less than columnLength value.
                    if ((resultItem.Length - index) <= columnLength) {
                        if (index == 0) {
                            itemToAdd = resultItem;
                        } else {
                            itemToAdd = "..." + resultItem.Substring(index, resultItem.Length - index);
                        }
                    } else {
                        if (index == 0) {
                          itemToAdd = resultItem.Substring(index, (columnLength - 3)) + "...";
                        } else {
                            // Truncate the string to show only columnLength - 6 characters as begining and trailing "..." has to be appended.
                            itemToAdd = "..." + resultItem.Substring(index, (columnLength - 6)) + "...";
                        }
                    }
                } else if (StringUtils.InvariantLCase(AutoTypeAheadDisplayFoundText).Equals("inmiddleofmatchedstring")) {
                    int subStringBeginIndex = (int)(columnLength / 2);
                    if (resultItem.Length <= columnLength) {
                        itemToAdd = resultItem;
                    } else {
                        // Sanity check at end of the string
                        if ((index + prefixText.Length) == columnLength) {
                            itemToAdd = "..." + resultItem.Substring((index - columnLength), index);
                        } else if ((resultItem.Length - index) < subStringBeginIndex) {
                            //  Display string from the end till columnLength value if, index is closer to the end of the string.
                            itemToAdd = "..." + resultItem.Substring(resultItem.Length - columnLength, resultItem.Length);
                        } else if (index <= subStringBeginIndex) {
                            // Sanity chet at beginning of the string
                            itemToAdd = resultItem.Substring(0, columnLength) + "...";
                        } else {
                            // Display string containing text before the prefixText occures and text after the prefixText
                            itemToAdd = "..." + resultItem.Substring(index - subStringBeginIndex, columnLength) + "...";
                        }
                    }
                } else if (StringUtils.InvariantLCase(AutoTypeAheadDisplayFoundText).Equals("atendofmatchedstring")) {
                     // Expression to find ending of the word which contains prefexText
                    System.Text.RegularExpressions.Regex regex1 = new System.Text.RegularExpressions.Regex("\\s", System.Text.RegularExpressions.RegexOptions.IgnoreCase); 
                    // Find the ending of the word which contains prefexText
                    if (regex1.IsMatch(resultItem, index + 1)) {
                        index = regex1.Match(resultItem, index + 1).Index;
                    }else{
                        // If the word which contains prefexText is the last word in string, regex1.IsMatch returns false.
                        index = resultItem.Length;
                    }
                    
                    if (index > resultItem.Length) {
                        index = resultItem.Length;
                    }
                    // If text from beginning of the string till index is less than columnLength value then, display string from the beginning till index.
                    if (index <= columnLength) {
                        if (index == resultItem.Length) {   //Make decision to append "..."
                            itemToAdd = resultItem.Substring(0, index);
                        } else {
                            itemToAdd = resultItem.Substring(0, index) + "...";
                        }
                    } else if (index == resultItem.Length) {
                        itemToAdd = "..." + resultItem.Substring(index - (columnLength - 3), columnLength - 3);
                    } else {
                        // Truncate the string to show only columnLength - 6 characters as begining and trailing "..." has to be appended.
                        itemToAdd = "..." + resultItem.Substring(index - (columnLength - 6), (columnLength - 6)) + "...";
                    }
                }
                
                // Remove newline character from itemToAdd
                int prefixTextIndex = itemToAdd.IndexOf(prefixText, StringComparison.CurrentCultureIgnoreCase);
                // If itemToAdd contains any newline after the search text then show text only till newline
                System.Text.RegularExpressions.Regex regex2 = new System.Text.RegularExpressions.Regex("(\r\n|\n)", System.Text.RegularExpressions.RegexOptions.IgnoreCase);
                int newLineIndexAfterPrefix = -1;
                if (regex2.IsMatch(itemToAdd, prefixTextIndex)){
                    newLineIndexAfterPrefix = regex2.Match(itemToAdd, prefixTextIndex).Index;
                }
                if ((newLineIndexAfterPrefix > -1)) {
                    if (itemToAdd.EndsWith("...")) {
                        itemToAdd = itemToAdd.Substring(0, newLineIndexAfterPrefix) + "...";
                    }
                    else {
                        itemToAdd = itemToAdd.Substring(0, newLineIndexAfterPrefix);
                    }
                }
                // If itemToAdd contains any newline before search text then show text which comes after newline
                System.Text.RegularExpressions.Regex regex3 = new System.Text.RegularExpressions.Regex("(\r\n|\n)", System.Text.RegularExpressions.RegexOptions.IgnoreCase | System.Text.RegularExpressions.RegexOptions.RightToLeft );
                int newLineIndexBeforePrefix = -1;
                if (regex3.IsMatch(itemToAdd, prefixTextIndex)){
                    newLineIndexBeforePrefix = regex3.Match(itemToAdd, prefixTextIndex).Index;
                }
                if ((newLineIndexBeforePrefix > -1)) {
                    if (itemToAdd.StartsWith("...")) {
                        itemToAdd = "..." + itemToAdd.Substring(newLineIndexBeforePrefix +regex3.Match(itemToAdd, prefixTextIndex).Length);
                    }
                    else {
                        itemToAdd = itemToAdd.Substring(newLineIndexBeforePrefix +regex3.Match(itemToAdd, prefixTextIndex).Length);
                    }
                }

                if (itemToAdd!= null && !resultList.Contains(itemToAdd)) {
                    resultList.Add(itemToAdd);
                    isAdded = true;
                }
            }
            return isAdded;
        }
        
        
    
        protected virtual void GetPageSize()
        {
        
            if (this.OwnerPagination.PageSize.Text.Length > 0) {
                try {
                    // this.PageSize = Convert.ToInt32(this.OwnerPagination.PageSize.Text);
                } catch (Exception ) {
                }
            }
        }

        protected virtual void AddNewRecords()
        {
            ArrayList newRecordList = new ArrayList();

            // Loop though all the record controls and if the record control
            // does not have a unique record id set, then create a record
            // and add to the list.
            if (!this.ResetData)
            {
                System.Web.UI.WebControls.Repeater rep = (System.Web.UI.WebControls.Repeater)(this.FindControl("OwnerTableControlRepeater"));
        if (rep == null){return;}

                foreach (System.Web.UI.WebControls.RepeaterItem repItem in rep.Items)
                {
                    // Loop through all rows in the table, set its DataSource and call DataBind().
                    OwnerTableControlRow recControl = (OwnerTableControlRow)(repItem.FindControl("OwnerTableControlRow"));

                    if (recControl.Visible && recControl.IsNewRecord) {
                        OwnerRecord rec = new OwnerRecord();
        
                        if (recControl.Address.Text != "") {
                            rec.Parse(recControl.Address.Text, OwnerTable.Address);
                  }
                
                        if (recControl.OwnerName.Text != "") {
                            rec.Parse(recControl.OwnerName.Text, OwnerTable.OwnerName);
                  }
                
                        newRecordList.Add(rec);
                    }
                }
            }

            // Add any new record to the list.
            for (int count = 1; count <= this.AddNewRecord; count++) {
                newRecordList.Insert(0, new OwnerRecord());
            }
            this.AddNewRecord = 0;

            // Finally , add any new records to the DataSource.
            if (newRecordList.Count > 0) {
                ArrayList finalList = new ArrayList(this.DataSource);
                finalList.InsertRange(0, newRecordList);

                this.DataSource = (OwnerRecord[])(finalList.ToArray(Type.GetType("V6MMYCS.Business.OwnerRecord")));
            }
        }

        
        public void AddToDeletedRecordIds(OwnerTableControlRow rec)
        {
            if (rec.IsNewRecord) {
                return;
            }

            if (this.DeletedRecordIds != null && this.DeletedRecordIds.Length > 0) {
                this.DeletedRecordIds += ",";
            }

            this.DeletedRecordIds += "[" + rec.RecordUniqueId + "]";
        }

        private bool InDeletedRecordIds(OwnerTableControlRow rec)            
        {
            if (this.DeletedRecordIds == null || this.DeletedRecordIds.Length == 0) {
                return (false);
            }

            return (this.DeletedRecordIds.IndexOf("[" + rec.RecordUniqueId + "]") >= 0);
        }

        private String _DeletedRecordIds;
        public String DeletedRecordIds {
            get {
                return (this._DeletedRecordIds);
            }
            set {
                this._DeletedRecordIds = value;
            }
        }
        
        // Get the filters' data for AddressFilter.
                
        protected virtual void PopulateAddressFilter(string selectedValue, int maxItems)
                    
        {
        
              
            // Setup the WHERE clause, 
                
            WhereClause wc = this.CreateWhereClause_AddressFilter();

                  
            OrderBy orderBy = new OrderBy(false, true);
            orderBy.Add(OwnerTable.Address, OrderByItem.OrderDir.Asc);

            string[] list = OwnerTable.GetValues(OwnerTable.Address, wc, orderBy, maxItems);
            
            this.AddressFilter.Items.Clear();
            
            foreach (string itemValue in list)
            {
                // Create the item and add to the list.
                string fvalue;
                if ( OwnerTable.Address.IsColumnValueTypeBoolean()) {
                    fvalue = itemValue;
                }else {
                    fvalue = OwnerTable.Address.Format(itemValue);
                }
                ListItem item = new ListItem(fvalue, itemValue);
                this.AddressFilter.Items.Add(item);
            }
                    
      // Add the All item.
            this.AddressFilter.Items.Insert(0, new ListItem(Page.GetResourceValue("Txt:All", "V6MMYCS"), "--ANY--"));		
        
      
            // Set the selected value.
            MiscUtils.SetSelectedValue(this.AddressFilter, selectedValue);

            
        }
            
        // Get the filters' data for OwnerNameFilter.
                
        protected virtual void PopulateOwnerNameFilter(string selectedValue, int maxItems)
                    
        {
        
              
            // Setup the WHERE clause, 
                
            WhereClause wc = this.CreateWhereClause_OwnerNameFilter();

                  
            OrderBy orderBy = new OrderBy(false, true);
            orderBy.Add(OwnerTable.OwnerName, OrderByItem.OrderDir.Asc);

            string[] list = OwnerTable.GetValues(OwnerTable.OwnerName, wc, orderBy, maxItems);
            
            this.OwnerNameFilter.Items.Clear();
            
            foreach (string itemValue in list)
            {
                // Create the item and add to the list.
                string fvalue;
                if ( OwnerTable.OwnerName.IsColumnValueTypeBoolean()) {
                    fvalue = itemValue;
                }else {
                    fvalue = OwnerTable.OwnerName.Format(itemValue);
                }
                ListItem item = new ListItem(fvalue, itemValue);
                this.OwnerNameFilter.Items.Add(item);
            }
                    
      // Add the All item.
            this.OwnerNameFilter.Items.Insert(0, new ListItem(Page.GetResourceValue("Txt:All", "V6MMYCS"), "--ANY--"));		
        
      
            // Set the selected value.
            MiscUtils.SetSelectedValue(this.OwnerNameFilter, selectedValue);

            
        }
            
    // Create a where clause for the filter AddressFilter.
    public virtual WhereClause CreateWhereClause_AddressFilter()
    {
        
      return new WhereClause();
          
    }
      
    // Create a where clause for the filter OwnerNameFilter.
    public virtual WhereClause CreateWhereClause_OwnerNameFilter()
    {
        
      return new WhereClause();
          
    }
      
    // Create a where clause for the filter OwnerSearchArea.
    public virtual WhereClause CreateWhereClause_OwnerSearchArea()
    {
        
      return new WhereClause();
          
    }
      
        private void Control_PreRender(object sender, System.EventArgs e)
        {
            try {
                DbUtils.StartTransaction();
                
                if (!this.Page.ErrorOnPage && (this.Page.IsPageRefresh || this.DataChanged || this.ResetData)) {
                    this.LoadData();
                    this.DataBind();
                }
                
            } catch (Exception ex) {
                BaseClasses.Utils.MiscUtils.RegisterJScriptAlert(this, "BUTTON_CLICK_MESSAGE", ex.Message);
            } finally {
                DbUtils.EndTransaction();
            }
        }
        
        protected override void SaveControlsToSession()
        {
            base.SaveControlsToSession();

            // Save filter controls to values to session.
        
            this.SaveToSession(this.AddressFilter, this.AddressFilter.SelectedValue);
                  
            this.SaveToSession(this.OwnerNameFilter, this.OwnerNameFilter.SelectedValue);
                  
            this.SaveToSession(this.OwnerSearchArea, this.OwnerSearchArea.Text);
                  
            
            // Save table control properties to the session.
            if (this.CurrentSortOrder != null) {
                this.SaveToSession(this, "Order_By", this.CurrentSortOrder.ToXmlString());
            }
            this.SaveToSession(this, "Page_Index", this.PageIndex.ToString());
            this.SaveToSession(this, "Page_Size", this.PageSize.ToString());
        
            this.SaveToSession(this, "DeletedRecordIds", this.DeletedRecordIds);
        
        }
        
        protected  void SaveControlsToSession_Ajax()
        {
            // Save filter controls to values to session.
          
      this.SaveToSession("AddressFilter_Ajax", this.AddressFilter.SelectedValue);
              
      this.SaveToSession("OwnerNameFilter_Ajax", this.OwnerNameFilter.SelectedValue);
              
      this.SaveToSession("OwnerSearchArea_Ajax", this.OwnerSearchArea.Text);
              
           HttpContext.Current.Session["AppRelativeVirtualPath"] = this.Page.AppRelativeVirtualPath;
         
        }
        
        protected override void ClearControlsFromSession()
        {
            base.ClearControlsFromSession();

            // Clear filter controls values from the session.
        
            this.RemoveFromSession(this.AddressFilter);
            this.RemoveFromSession(this.OwnerNameFilter);
            this.RemoveFromSession(this.OwnerSearchArea);
            
            // Clear table properties from the session.
            this.RemoveFromSession(this, "Order_By");
            this.RemoveFromSession(this, "Page_Index");
            this.RemoveFromSession(this, "Page_Size");
            
            this.RemoveFromSession(this, "DeletedRecordIds");
            
        }

        protected override void LoadViewState(object savedState)
        {
            base.LoadViewState(savedState);

            string orderByStr = (string)ViewState["OwnerTableControl_OrderBy"];
            if (orderByStr != null && orderByStr.Length > 0) {
                this.CurrentSortOrder = BaseClasses.Data.OrderBy.FromXmlString(orderByStr);
            } else {
                this.CurrentSortOrder = new OrderBy(true, true);
            }

            if (ViewState["Page_Index"] != null) {
                this.PageIndex = (int)ViewState["Page_Index"];
            }

            if (ViewState["Page_Size"] != null) {
                this.PageSize = (int)ViewState["Page_Size"];
            }
        
            this.DeletedRecordIds = (string)this.ViewState["DeletedRecordIds"];
        
        }

        protected override object SaveViewState()
        {            
            if (this.CurrentSortOrder != null) {
                this.ViewState["OwnerTableControl_OrderBy"] = this.CurrentSortOrder.ToXmlString();
            }
            
            this.ViewState["Page_Index"] = this.PageIndex;
            this.ViewState["Page_Size"] = this.PageSize;
        
            this.ViewState["DeletedRecordIds"] = this.DeletedRecordIds;
        
            return (base.SaveViewState());
        }

        // Generate the event handling functions for pagination events.
        
        // event handler for ImageButton
        public virtual void OwnerPagination_FirstPage_Click(object sender, ImageClickEventArgs args)
        {
        
            try {
                
            this.PageIndex = 0;
            this.DataChanged = true;
      
            } catch (Exception ex) {
                this.Page.ErrorOnPage = true;
    
            BaseClasses.Utils.MiscUtils.RegisterJScriptAlert(this, "BUTTON_CLICK_MESSAGE", ex.Message);
          
            } finally {
    
            }
    
        }
            
        // event handler for ImageButton
        public virtual void OwnerPagination_LastPage_Click(object sender, ImageClickEventArgs args)
        {
        
            try {
                
            this.DisplayLastPage = true;
            this.DataChanged = true;
      
            } catch (Exception ex) {
                this.Page.ErrorOnPage = true;
    
            BaseClasses.Utils.MiscUtils.RegisterJScriptAlert(this, "BUTTON_CLICK_MESSAGE", ex.Message);
          
            } finally {
    
            }
    
        }
            
        // event handler for ImageButton
        public virtual void OwnerPagination_NextPage_Click(object sender, ImageClickEventArgs args)
        {
        
            try {
                
            this.PageIndex += 1;
            this.DataChanged = true;
      
            } catch (Exception ex) {
                this.Page.ErrorOnPage = true;
    
            BaseClasses.Utils.MiscUtils.RegisterJScriptAlert(this, "BUTTON_CLICK_MESSAGE", ex.Message);
          
            } finally {
    
            }
    
        }
            
        // event handler for LinkButton
        public virtual void OwnerPagination_PageSizeButton_Click(object sender, EventArgs args)
        {
        
            try {
                
            this.DataChanged = true;
      
            this.PageSize = Convert.ToInt32(this.OwnerPagination.PageSize.Text);
      
            this.PageIndex = Convert.ToInt32(this.OwnerPagination.CurrentPage.Text) - 1;
      
            } catch (Exception ex) {
                this.Page.ErrorOnPage = true;
    
            BaseClasses.Utils.MiscUtils.RegisterJScriptAlert(this, "BUTTON_CLICK_MESSAGE", ex.Message);
          
            } finally {
    
            }
    
        }
            
        // event handler for ImageButton
        public virtual void OwnerPagination_PreviousPage_Click(object sender, ImageClickEventArgs args)
        {
        
            try {
                
            if (this.PageIndex > 0) {
                this.PageIndex -= 1;
                this.DataChanged = true;
            }
      
            } catch (Exception ex) {
                this.Page.ErrorOnPage = true;
    
            BaseClasses.Utils.MiscUtils.RegisterJScriptAlert(this, "BUTTON_CLICK_MESSAGE", ex.Message);
          
            } finally {
    
            }
    
        }
            

        // Generate the event handling functions for sorting events.
        
        // event handler for FieldSort
        public virtual void AddressLabel1_Click(object sender, EventArgs args)
        {
              
            OrderByItem sd = this.CurrentSortOrder.Find(OwnerTable.Address);
            if (sd != null) {
                sd.Reverse();
            } else {
                this.CurrentSortOrder.Reset();
                this.CurrentSortOrder.Add(OwnerTable.Address, OrderByItem.OrderDir.Asc);
            }

            this.DataChanged = true;
              
        }
            
        // event handler for FieldSort
        public virtual void OwnerNameLabel1_Click(object sender, EventArgs args)
        {
              
            OrderByItem sd = this.CurrentSortOrder.Find(OwnerTable.OwnerName);
            if (sd != null) {
                sd.Reverse();
            } else {
                this.CurrentSortOrder.Reset();
                this.CurrentSortOrder.Add(OwnerTable.OwnerName, OrderByItem.OrderDir.Asc);
            }

            this.DataChanged = true;
              
        }
            

        // Generate the event handling functions for button events.
        
        // event handler for ImageButton
        public virtual void OwnerCopyButton_Click(object sender, ImageClickEventArgs args)
        {
        
            string url = @"../Owner/AddOwner.aspx?Owner={PK}";
            bool shouldRedirect = true;
            string TargetKey;
            string tk = null;
            TargetKey = tk;
            
            try {
                DbUtils.StartTransaction();
                
                url = this.ModifyRedirectUrl(url, "",false);
                url = this.Page.ModifyRedirectUrl(url, "",false);
                        this.Page.CommitTransaction(sender);
    
      
            } catch (Exception ex) {
                this.Page.RollBackTransaction(sender);
                shouldRedirect = false;
                this.Page.ErrorOnPage = true;
    
            BaseClasses.Utils.MiscUtils.RegisterJScriptAlert(this, "BUTTON_CLICK_MESSAGE", ex.Message);
          
            } finally {
                DbUtils.EndTransaction();
            }
            if (shouldRedirect) {
                this.Page.ShouldSaveControlsToSession = true;
                this.Page.Response.Redirect(url);
            }
        
            else if (TargetKey != null && !shouldRedirect){
            this.Page.ShouldSaveControlsToSession = true ; 
            this.Page.CloseWindow(true);
            }
        
        }
            
        // event handler for ImageButton
        public virtual void OwnerDeleteButton_Click(object sender, ImageClickEventArgs args)
        {
        
            try {
                DbUtils.StartTransaction();
                
            if (!this.Page.IsPageRefresh) {
        
                this.DeleteSelectedRecords(false);
          
            }
                this.Page.CommitTransaction(sender);
    
      
            } catch (Exception ex) {
                this.Page.RollBackTransaction(sender);
                this.Page.ErrorOnPage = true;
    
            BaseClasses.Utils.MiscUtils.RegisterJScriptAlert(this, "BUTTON_CLICK_MESSAGE", ex.Message);
          
            } finally {
                DbUtils.EndTransaction();
            }
    
        }
            
        // event handler for ImageButton
        public virtual void OwnerEditButton_Click(object sender, ImageClickEventArgs args)
        {
        
            string url = @"../Owner/EditOwner.aspx?Owner={PK}";
            bool shouldRedirect = true;
            string TargetKey;
            string tk = null;
            TargetKey = tk;
            
            try {
                DbUtils.StartTransaction();
                
                url = this.ModifyRedirectUrl(url, "",false);
                url = this.Page.ModifyRedirectUrl(url, "",false);
                        this.Page.CommitTransaction(sender);
    
      
            } catch (Exception ex) {
                this.Page.RollBackTransaction(sender);
                shouldRedirect = false;
                this.Page.ErrorOnPage = true;
    
            BaseClasses.Utils.MiscUtils.RegisterJScriptAlert(this, "BUTTON_CLICK_MESSAGE", ex.Message);
          
            } finally {
                DbUtils.EndTransaction();
            }
            if (shouldRedirect) {
                this.Page.ShouldSaveControlsToSession = true;
                this.Page.Response.Redirect(url);
            }
        
            else if (TargetKey != null && !shouldRedirect){
            this.Page.ShouldSaveControlsToSession = true ; 
            this.Page.CloseWindow(true);
            }
        
        }
            
        // event handler for ImageButton
        public virtual void OwnerExportButton_Click(object sender, ImageClickEventArgs args)
        {
        
            try {
                DbUtils.StartTransaction();
                
              WhereClause wc = CreateWhereClause();
              OrderBy orderBy = null;
              
              orderBy = CreateOrderBy();
              
          BaseColumn[] columns = new BaseColumn[] {
                       OwnerTable.OwnerName,
             OwnerTable.Address,
             null};
            ExportData rep = new ExportData(OwnerTable.Instance,wc,orderBy,columns);
            rep.ExportToCSV(this.Page.Response);
                  this.Page.CommitTransaction(sender);
    
      
            } catch (Exception ex) {
                this.Page.RollBackTransaction(sender);
                this.Page.ErrorOnPage = true;
    
            BaseClasses.Utils.MiscUtils.RegisterJScriptAlert(this, "BUTTON_CLICK_MESSAGE", ex.Message);
          
            } finally {
                DbUtils.EndTransaction();
            }
    
        }
            
        // event handler for ImageButton
        public virtual void OwnerExportExcelButton_Click(object sender, ImageClickEventArgs args)
        {
        
            try {
                DbUtils.StartTransaction();
                
            // To customize the columns or the format, override this function in Section 1 of the page
            // and modify it to your liking.
            // Build the where clause based on the current filter and search criteria
            // Create the Order By clause based on the user's current sorting preference.
            
                WhereClause wc = CreateWhereClause();
                OrderBy orderBy = null;
                
                orderBy = CreateOrderBy();
                
            // Create an instance of the Excel report class with the table class, where clause and order by.
            ExportData excelReport = new ExportData(OwnerTable.Instance, wc, orderBy);
            // Add each of the columns in order of export.
            // To customize the data type, change the second parameter of the new ExcelColumn to be
            // a format string from Excel's Format Cell menu. For example "dddd, mmmm dd, yyyy h:mm AM/PM;@", "#,##0.00"
             excelReport.AddColumn(new ExcelColumn(OwnerTable.OwnerName, @"Default"));
             excelReport.AddColumn(new ExcelColumn(OwnerTable.Address, @"Default"));

            excelReport.ExportToExcel(this.Page.Response);
                    this.Page.CommitTransaction(sender);
    
      
            } catch (Exception ex) {
                this.Page.RollBackTransaction(sender);
                this.Page.ErrorOnPage = true;
    
            BaseClasses.Utils.MiscUtils.RegisterJScriptAlert(this, "BUTTON_CLICK_MESSAGE", ex.Message);
          
            } finally {
                DbUtils.EndTransaction();
            }
    
        }
            
        // event handler for ImageButton
        public virtual void OwnerImportButton_Click(object sender, ImageClickEventArgs args)
        {
        
            string url = @"../Shared/SelectFileToImport.aspx?TableName=Owner";
            try {
                DbUtils.StartTransaction();
                
            string script = "window.open('" + this.Page.EncryptUrlParameter(url) + "','importWindow', 'width=700, height=500,top=' +(screen.availHeight-500)/2 + ',left=' + (screen.availWidth-700)/2+ ', resizable=yes, scrollbars=yes,modal=yes');";
            //  if(! this.Page.ClientScript.IsStartupScriptRegistered("OpenPopup"))
            // {
            ScriptManager.RegisterStartupScript(this.Page, Page.GetType(), "OpenPopup", script, true);
            //  }
                    this.Page.CommitTransaction(sender);
    
      
            } catch (Exception ex) {
                this.Page.RollBackTransaction(sender);
                this.Page.ErrorOnPage = true;
    
            BaseClasses.Utils.MiscUtils.RegisterJScriptAlert(this, "BUTTON_CLICK_MESSAGE", ex.Message);
          
            } finally {
                DbUtils.EndTransaction();
            }
    
        }
            
        // event handler for ImageButton
        public virtual void OwnerNewButton_Click(object sender, ImageClickEventArgs args)
        {
        
            string url = @"../Owner/AddOwner.aspx";
            bool shouldRedirect = true;
            string TargetKey;
            string tk = null;
            TargetKey = tk;
            
            try {
                DbUtils.StartTransaction();
                
                url = this.ModifyRedirectUrl(url, "",false);
                url = this.Page.ModifyRedirectUrl(url, "",false);
                        this.Page.CommitTransaction(sender);
    
      
            } catch (Exception ex) {
                this.Page.RollBackTransaction(sender);
                shouldRedirect = false;
                this.Page.ErrorOnPage = true;
    
            BaseClasses.Utils.MiscUtils.RegisterJScriptAlert(this, "BUTTON_CLICK_MESSAGE", ex.Message);
          
            } finally {
                DbUtils.EndTransaction();
            }
            if (shouldRedirect) {
                this.Page.ShouldSaveControlsToSession = true;
                this.Page.Response.Redirect(url);
            }
        
            else if (TargetKey != null && !shouldRedirect){
            this.Page.ShouldSaveControlsToSession = true ; 
            this.Page.CloseWindow(true);
            }
        
        }
            
        // event handler for ImageButton
        public virtual void OwnerPDFButton_Click(object sender, ImageClickEventArgs args)
        {
        
            try {
                DbUtils.StartTransaction();
                

        PDFReport report = new PDFReport();

        report.SpecificReportFileName = Page.Server.MapPath("ShowOwnerTable.OwnerPDFButton.report");
                // report.Title replaces the value tag of page header and footer containing ${ReportTitle}
                report.Title = "Owner";
                // If ShowOwnerTable.OwnerPDFButton.report specifies a valid report template,
                // AddColumn methods will generate a report template.   
                // Each AddColumn method-call specifies a column
                // The 1st parameter represents the text of the column header
                // The 2nd parameter represents the horizontal alignment of the column header
                // The 3rd parameter represents the text format of the column detail
                // The 4th parameter represents the horizontal alignment of the column detail
                // The 5th parameter represents the relative width of the column
                 report.AddColumn(OwnerTable.OwnerName.Name, ReportEnum.Align.Left, "${OwnerTable.OwnerName.Name}", ReportEnum.Align.Left, 30);
                 report.AddColumn(OwnerTable.Address.Name, ReportEnum.Align.Left, "${OwnerTable.Address.Name}", ReportEnum.Align.Left, 30);

            WhereClause whereClause = CreateWhereClause();
            
            OrderBy orderBy = CreateOrderBy();
                

                int rowsPerQuery = 1000;
                int pageNum = 0;
                int recordCount = 0;
                int totalRecords = OwnerTable.GetRecordCount(whereClause);
                                
                report.Page = Page.GetResourceValue("Txt:Page", "V6MMYCS");
                report.ApplicationPath = this.Page.MapPath(Page.Request.ApplicationPath);

                ColumnList columns = OwnerTable.GetColumnList();
                OwnerRecord[] records = null;
                do
                {
                    records = OwnerTable.GetRecords(whereClause, orderBy, pageNum, rowsPerQuery);
                    if (records != null && records.Length > 0 && whereClause.RunQuery)
                    {
                        foreach ( OwnerRecord record in records)
                        {
                            // AddData method takes four parameters   
                            // The 1st parameter represent the data format
                            // The 2nd parameter represent the data value
                            // The 3rd parameter represent the default alignment of column using the data
                            // The 4th parameter represent the maximum length of the data value being shown
                             report.AddData("${OwnerTable.OwnerName.Name}", record.Format(OwnerTable.OwnerName), ReportEnum.Align.Left, 100);
                             report.AddData("${OwnerTable.Address.Name}", record.Format(OwnerTable.Address), ReportEnum.Align.Left, 100);

                            report.WriteRow();
                        }
                        pageNum++;
                        recordCount += records.Length;
                    }
                }
                while (records != null && recordCount < totalRecords && whereClause.RunQuery);
                report.Close();
                BaseClasses.Utils.NetUtils.WriteResponseBinaryAttachment(this.Page.Response, report.Title + ".pdf", report.ReportInByteArray, 0, true);
                      this.Page.CommitTransaction(sender);
    
      
            } catch (Exception ex) {
                this.Page.RollBackTransaction(sender);
                this.Page.ErrorOnPage = true;
    
            BaseClasses.Utils.MiscUtils.RegisterJScriptAlert(this, "BUTTON_CLICK_MESSAGE", ex.Message);
          
            } finally {
                DbUtils.EndTransaction();
            }
    
        }
            
        // event handler for ImageButton
        public virtual void OwnerRefreshButton_Click(object sender, ImageClickEventArgs args)
        {
        
            try {
                
            ((OwnerTableControl)(this.Page.FindControlRecursively("OwnerTableControl"))).ResetData = true;
                
            } catch (Exception ex) {
                this.Page.ErrorOnPage = true;
    
            BaseClasses.Utils.MiscUtils.RegisterJScriptAlert(this, "BUTTON_CLICK_MESSAGE", ex.Message);
          
            } finally {
    
            }
    
        }
            
        // event handler for ImageButton
        public virtual void OwnerResetButton_Click(object sender, ImageClickEventArgs args)
        {
        
            try {
                
              this.AddressFilter.ClearSelection();
            
              this.OwnerNameFilter.ClearSelection();
            
              this.OwnerSearchArea.Text = "";
            
              this.CurrentSortOrder.Reset();
              if (this.InSession(this, "Order_By")) {
              this.CurrentSortOrder = OrderBy.FromXmlString(this.GetFromSession(this, "Order_By", null));
              } else {
              this.CurrentSortOrder = new OrderBy(true, true);
            
            }
                

            this.DataChanged = true;
                
            } catch (Exception ex) {
                this.Page.ErrorOnPage = true;
    
            BaseClasses.Utils.MiscUtils.RegisterJScriptAlert(this, "BUTTON_CLICK_MESSAGE", ex.Message);
          
            } finally {
    
            }
    
        }
            
        // event handler for ImageButton
        public virtual void OwnerWordButton_Click(object sender, ImageClickEventArgs args)
        {
        
            try {
                DbUtils.StartTransaction();
                

        WordReport report = new WordReport();

        report.SpecificReportFileName = Page.Server.MapPath("ShowOwnerTable.OwnerWordButton.word");
                // report.Title replaces the value tag of page header and footer containing ${ReportTitle}
                report.Title = "Owner";
                // If ShowOwnerTable.OwnerWordButton.report specifies a valid report template,
                // AddColumn methods will generate a report template.
                // Each AddColumn method-call specifies a column
                // The 1st parameter represents the text of the column header
                // The 2nd parameter represents the horizontal alignment of the column header
                // The 3rd parameter represents the text format of the column detail
                // The 4th parameter represents the horizontal alignment of the column detail
                // The 5th parameter represents the relative width of the column
                 report.AddColumn(OwnerTable.OwnerName.Name, ReportEnum.Align.Left, "${OwnerTable.OwnerName.Name}", ReportEnum.Align.Left, 30);
                 report.AddColumn(OwnerTable.Address.Name, ReportEnum.Align.Left, "${OwnerTable.Address.Name}", ReportEnum.Align.Left, 30);

            WhereClause whereClause = CreateWhereClause();
            
            OrderBy orderBy = CreateOrderBy();
                

                int rowsPerQuery = 1000;
                int pageNum = 0;
                int recordCount = 0;
                int totalRecords = OwnerTable.GetRecordCount(whereClause);

                report.Page = Page.GetResourceValue("Txt:Page", "V6MMYCS");
                report.ApplicationPath = this.Page.MapPath(Page.Request.ApplicationPath);

                ColumnList columns = OwnerTable.GetColumnList();
                OwnerRecord[] records = null;
                do
                {
                    records = OwnerTable.GetRecords(whereClause, orderBy, pageNum, rowsPerQuery);
                    if (records != null && records.Length > 0 && whereClause.RunQuery)
                    {
                        foreach ( OwnerRecord record in records)
                        {
                            // AddData method takes four parameters
                            // The 1st parameter represents the data format
                            // The 2nd parameter represents the data value
                            // The 3rd parameter represents the default alignment of column using the data
                            // The 4th parameter represents the maximum length of the data value being shown
                             report.AddData("${OwnerTable.OwnerName.Name}", record.Format(OwnerTable.OwnerName), ReportEnum.Align.Left, 100);
                             report.AddData("${OwnerTable.Address.Name}", record.Format(OwnerTable.Address), ReportEnum.Align.Left, 100);

                            report.WriteRow();
                        }
                        pageNum++;
                        recordCount += records.Length;
                    }
                }
                while (records != null && recordCount < totalRecords && whereClause.RunQuery);
                report.save();
                BaseClasses.Utils.NetUtils.WriteResponseBinaryAttachment(this.Page.Response, report.Title + ".doc", report.ReportInByteArray, 0, true);
                    this.Page.CommitTransaction(sender);
    
      
            } catch (Exception ex) {
                this.Page.RollBackTransaction(sender);
                this.Page.ErrorOnPage = true;
    
            BaseClasses.Utils.MiscUtils.RegisterJScriptAlert(this, "BUTTON_CLICK_MESSAGE", ex.Message);
          
            } finally {
                DbUtils.EndTransaction();
            }
    
        }
            
        // event handler for Button with Layout
        public virtual void OwnerSearchButton_Click(object sender, EventArgs args)
        {
              
            try {
                
            this.DataChanged = true;
      
            } catch (Exception ex) {
                this.Page.ErrorOnPage = true;
    
            BaseClasses.Utils.MiscUtils.RegisterJScriptAlert(this, "BUTTON_CLICK_MESSAGE", ex.Message);
          
            } finally {
    
            }
    
        }
            

        // Generate the event handling functions for filter and search events.
        
        // event handler for FieldFilter
        protected virtual void AddressFilter_SelectedIndexChanged(object sender, EventArgs args)
        {
            this.DataChanged = true;
        }
            
        // event handler for FieldFilter
        protected virtual void OwnerNameFilter_SelectedIndexChanged(object sender, EventArgs args)
        {
            this.DataChanged = true;
        }
            

        // verify the processing details for these properties
        private int _PageSize;
        public int PageSize {
            get {
                return this._PageSize;
            }
            set {
                this._PageSize = value;
            }
        }

        private int _PageIndex;
        public int PageIndex {
            get {
                // _PageSize return (the PageIndex);
                return this._PageIndex;
            }
            set {
                this._PageIndex = value;
            }
        }

        private int _TotalRecords;
        public int TotalRecords {
            get {
                return (this._TotalRecords);
            }
            set {
                if (this.PageSize > 0) {
                    this.TotalPages = Convert.ToInt32(Math.Ceiling(Convert.ToDouble(value) / Convert.ToDouble(this.PageSize)));
                }
                this._TotalRecords = value;
            }
        }

        private int _TotalPages;
        public int TotalPages {
            get {
                return this._TotalPages;
            }
            set {
                this._TotalPages = value;
            }
        }

        private bool _DisplayLastPage;
        public bool DisplayLastPage {
            get {
                return this._DisplayLastPage;
            }
            set {
                this._DisplayLastPage = value;
            }
        }

        private bool _DataChanged = false;
        public bool DataChanged {
            get {
                return this._DataChanged;
            }
            set {
                this._DataChanged = value;
            }
        }

        private bool _ResetData = false;
        public bool ResetData {
            get {
                return this._ResetData;
            }
            set {
                this._ResetData = value;
            }
        }

        private int _AddNewRecord = 0;
        public int AddNewRecord {
            get {
                return this._AddNewRecord;
            }
            set {
                this._AddNewRecord = value;
            }
        }

        private OrderBy _CurrentSortOrder = null;
        public OrderBy CurrentSortOrder {
            get {
                return this._CurrentSortOrder;
            }
            set {
                this._CurrentSortOrder = value;
            }
        }

        private OwnerRecord[] _DataSource = null;
        public  OwnerRecord[] DataSource {
            get {
                return this._DataSource;
            }
            set {
                this._DataSource = value;
            }
        }

#region "Helper Properties"
        
        public System.Web.UI.WebControls.DropDownList AddressFilter {
            get {
                return (System.Web.UI.WebControls.DropDownList)BaseClasses.Utils.MiscUtils.FindControlRecursively(this, "AddressFilter");
            }
        }
        
        public System.Web.UI.WebControls.Literal AddressLabel {
            get {
                return (System.Web.UI.WebControls.Literal)BaseClasses.Utils.MiscUtils.FindControlRecursively(this, "AddressLabel");
            }
        }
        
        public System.Web.UI.WebControls.LinkButton AddressLabel1 {
            get {
                return (System.Web.UI.WebControls.LinkButton)BaseClasses.Utils.MiscUtils.FindControlRecursively(this, "AddressLabel1");
            }
        }
        
        public System.Web.UI.WebControls.ImageButton OwnerCopyButton {
            get {
                return (System.Web.UI.WebControls.ImageButton)BaseClasses.Utils.MiscUtils.FindControlRecursively(this, "OwnerCopyButton");
            }
        }
        
        public System.Web.UI.WebControls.ImageButton OwnerDeleteButton {
            get {
                return (System.Web.UI.WebControls.ImageButton)BaseClasses.Utils.MiscUtils.FindControlRecursively(this, "OwnerDeleteButton");
            }
        }
        
        public System.Web.UI.WebControls.ImageButton OwnerEditButton {
            get {
                return (System.Web.UI.WebControls.ImageButton)BaseClasses.Utils.MiscUtils.FindControlRecursively(this, "OwnerEditButton");
            }
        }
        
        public System.Web.UI.WebControls.ImageButton OwnerExportButton {
            get {
                return (System.Web.UI.WebControls.ImageButton)BaseClasses.Utils.MiscUtils.FindControlRecursively(this, "OwnerExportButton");
            }
        }
        
        public System.Web.UI.WebControls.ImageButton OwnerExportExcelButton {
            get {
                return (System.Web.UI.WebControls.ImageButton)BaseClasses.Utils.MiscUtils.FindControlRecursively(this, "OwnerExportExcelButton");
            }
        }
        
        public System.Web.UI.WebControls.ImageButton OwnerImportButton {
            get {
                return (System.Web.UI.WebControls.ImageButton)BaseClasses.Utils.MiscUtils.FindControlRecursively(this, "OwnerImportButton");
            }
        }
        
        public System.Web.UI.WebControls.DropDownList OwnerNameFilter {
            get {
                return (System.Web.UI.WebControls.DropDownList)BaseClasses.Utils.MiscUtils.FindControlRecursively(this, "OwnerNameFilter");
            }
        }
        
        public System.Web.UI.WebControls.Literal OwnerNameLabel {
            get {
                return (System.Web.UI.WebControls.Literal)BaseClasses.Utils.MiscUtils.FindControlRecursively(this, "OwnerNameLabel");
            }
        }
        
        public System.Web.UI.WebControls.LinkButton OwnerNameLabel1 {
            get {
                return (System.Web.UI.WebControls.LinkButton)BaseClasses.Utils.MiscUtils.FindControlRecursively(this, "OwnerNameLabel1");
            }
        }
        
        public System.Web.UI.WebControls.ImageButton OwnerNewButton {
            get {
                return (System.Web.UI.WebControls.ImageButton)BaseClasses.Utils.MiscUtils.FindControlRecursively(this, "OwnerNewButton");
            }
        }
        
        public V6MMYCS.UI.IPagination OwnerPagination {
            get {
                return (V6MMYCS.UI.IPagination)BaseClasses.Utils.MiscUtils.FindControlRecursively(this, "OwnerPagination");
            }
        }
        
        public System.Web.UI.WebControls.ImageButton OwnerPDFButton {
            get {
                return (System.Web.UI.WebControls.ImageButton)BaseClasses.Utils.MiscUtils.FindControlRecursively(this, "OwnerPDFButton");
            }
        }
        
        public System.Web.UI.WebControls.ImageButton OwnerRefreshButton {
            get {
                return (System.Web.UI.WebControls.ImageButton)BaseClasses.Utils.MiscUtils.FindControlRecursively(this, "OwnerRefreshButton");
            }
        }
        
        public System.Web.UI.WebControls.ImageButton OwnerResetButton {
            get {
                return (System.Web.UI.WebControls.ImageButton)BaseClasses.Utils.MiscUtils.FindControlRecursively(this, "OwnerResetButton");
            }
        }
        
        public System.Web.UI.WebControls.TextBox OwnerSearchArea {
            get {
                return (System.Web.UI.WebControls.TextBox)BaseClasses.Utils.MiscUtils.FindControlRecursively(this, "OwnerSearchArea");
            }
        }
        
        public V6MMYCS.UI.IThemeButton OwnerSearchButton {
            get {
                return (V6MMYCS.UI.IThemeButton)BaseClasses.Utils.MiscUtils.FindControlRecursively(this, "OwnerSearchButton");
            }
        }
        
        public System.Web.UI.WebControls.Literal OwnerTitle {
            get {
                return (System.Web.UI.WebControls.Literal)BaseClasses.Utils.MiscUtils.FindControlRecursively(this, "OwnerTitle");
            }
        }
        
        public System.Web.UI.WebControls.CheckBox OwnerToggleAll {
            get {
                return (System.Web.UI.WebControls.CheckBox)BaseClasses.Utils.MiscUtils.FindControlRecursively(this, "OwnerToggleAll");
            }
        }
        
        public System.Web.UI.WebControls.ImageButton OwnerWordButton {
            get {
                return (System.Web.UI.WebControls.ImageButton)BaseClasses.Utils.MiscUtils.FindControlRecursively(this, "OwnerWordButton");
            }
        }
        
#endregion

#region "Helper Functions"
        
        public override string ModifyRedirectUrl(string url, string arg, bool bEncrypt)
        {
            return this.Page.EvaluateExpressions(url, arg, bEncrypt, this);
        }
        
        public override string EvaluateExpressions(string url, string arg, bool bEncrypt)
        {
            bool needToProcess = AreAnyUrlParametersForMe(url, arg);
            if (needToProcess) {
                OwnerTableControlRow recCtl = this.GetSelectedRecordControl();
                if (recCtl == null && url.IndexOf("{") >= 0) {
                    // Localization.
                    throw new Exception(Page.GetResourceValue("Err:NoRecSelected", "V6MMYCS"));
                }

                OwnerRecord rec = null;
                if (recCtl != null) {
                    rec = recCtl.GetRecord();
                }
                return EvaluateExpressions(url, arg, rec, bEncrypt);
            }
            return url;
        }
          
        public int GetSelectedRecordIndex()
        {
            int counter = 0;
            foreach (OwnerTableControlRow recControl in this.GetRecordControls())
            {
                if (recControl.OwnerRecordRowSelection.Checked) {
                    return counter;
                }
                counter += 1;
            }
            return -1;
        }
        
        public OwnerTableControlRow GetSelectedRecordControl()
        {
        OwnerTableControlRow[] selectedList = this.GetSelectedRecordControls();
            if (selectedList.Length == 0) {
            return null;
            }
            return selectedList[0];
          
        }

        public OwnerTableControlRow[] GetSelectedRecordControls()
        {
        
            ArrayList selectedList = new ArrayList(25);
            foreach (OwnerTableControlRow recControl in this.GetRecordControls())
            {
                if (recControl.OwnerRecordRowSelection.Checked) {
                    selectedList.Add(recControl);
                }
            }
            return (OwnerTableControlRow[])(selectedList.ToArray(Type.GetType("V6MMYCS.UI.Controls.ShowOwnerTable.OwnerTableControlRow")));
          
        }

        public virtual void DeleteSelectedRecords(bool deferDeletion)
        {
            OwnerTableControlRow[] recList = this.GetSelectedRecordControls();
            if (recList.Length == 0) {
                // Localization.
                throw new Exception(Page.GetResourceValue("Err:NoRecSelected", "V6MMYCS"));
            }
            
            foreach (OwnerTableControlRow recCtl in recList)
            {
                if (deferDeletion) {
                    if (!recCtl.IsNewRecord) {
                
                        this.AddToDeletedRecordIds(recCtl);
                  
                    }
                    recCtl.Visible = false;
                
                    recCtl.OwnerRecordRowSelection.Checked = false;
                
                } else {
                
                    recCtl.Delete();
                    this.DataChanged = true;
                    this.ResetData = true;
                  
                }
            }
        }

        public OwnerTableControlRow[] GetRecordControls()
        {
            ArrayList recList = new ArrayList();
            System.Web.UI.WebControls.Repeater rep = (System.Web.UI.WebControls.Repeater)this.FindControl("OwnerTableControlRepeater");
      if (rep == null){return null;}

            foreach (System.Web.UI.WebControls.RepeaterItem repItem in rep.Items)
            {
                OwnerTableControlRow recControl = (OwnerTableControlRow)repItem.FindControl("OwnerTableControlRow");
                recList.Add(recControl);
            }

            return (OwnerTableControlRow[])recList.ToArray(Type.GetType("V6MMYCS.UI.Controls.ShowOwnerTable.OwnerTableControlRow"));
        }

        public new BaseApplicationPage Page {
            get {
                return ((BaseApplicationPage)base.Page);
            }
        }

    #endregion

    

    }
  

#endregion
    
  
}

  